/*
    NullBot Robot Client 

    (C) 2005-2011 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
*/


#include <windows.h>

#pragma hdrstop

#include "types.h"


#include "utility.h"
#include "config.h"
#include "main.h"
#include "network.h"
#include "camera.h"


#include "automode.h"

#include "robot.h"
#include "target.h"
#include "types.h"
#include "automode.h"



#define MODULE_NAME "[Input] "


/* Inital key setup */
void main_class::reset_keys( void )
{
    log(MODULE_NAME "reset_keys\n");

    for (unsigned int i = 0; i < 256; i++) 
        keys[i] = false;

    update_movement();

    gui_speed = 0.3;   
}
/* End of reset_keys */


/* Deal with changed key values */
void main_class::update_movement( void  )
{
//    log(MODULE_NAME "update_movement\n");

    if (robot == NULL) return;



//      if (keys[VK_RIGHT])    robot->move_pan(-3);
//      if (keys[VK_LEFT])    robot->move_pan(3);
    
//    if (keys[VK_RIGHT] && robot->pan > 3) robot->pan -= 3;
//    if (keys[VK_LEFT] && robot->pan < 252) robot->pan += 3;


    if (keys['W']) 
    {
        if (keys['A']) robot->motion( gui_speed, 0.99 ); else
        if (keys['D']) robot->motion( gui_speed, -0.99); else
             robot->motion( gui_speed, 0 );
    }else
    if (keys['S']) 
    {
        if (keys['A']) robot->motion( -gui_speed, 0.99); else
        if (keys['D']) robot->motion( -gui_speed, -0.99 ); else
            robot->motion( -gui_speed, 0 );
    } else
    
    
    if (keys['A']) { robot->motion( 0, 1 ); } else // left spin
    if (keys['D']) { robot->motion(0, -1 ); } else // right spin
        robot->motion( 0, 0 ); 


}
/* End of update movement */


/* Called when a key is pressed */
void main_class::process_key_down(unsigned char key)
{
    log(MODULE_NAME "process_key_down\n");

    if (key == 27) PostQuitMessage(0);

 //    if (keys[VK_SPACE]) show_stats = !show_stats;
    

    // toggle logging
    if (key == 'L')
    {
        set_logging(!get_logging());
        
        
        if (get_logging())    
            alert(MODULE_NAME "Logging enabled");
        else
            alert(MODULE_NAME "Logging disabled");
    } else

    // toggle debug display
    if (key == 'V') 
    {
        display_text = !display_text;      
        
        update_display_mode();
        
        //InvalidateRect (hwnd, NULL, FALSE);              

        // resize the window if needed
/*        if(display_text)
            display_y -= text_area_height;
        else
            display_y += text_area_height;*/
    } else


    //    if (key == VK_SPACE && !keys[VK_SPACE])  fire_on(); else
    //    if (key == 'V') d_frame = !d_frame; else


    if (key == 'T') 
    {
        if (robot->get_targetting())
        {
            alert(MODULE_NAME "Targeting disabled");
            robot->set_targetting(0);
        }
        else
        {
            alert(MODULE_NAME "Targeting enabled");
            robot->set_targetting(1);
        }     
    }    else
    
    if (key == 'M') 
    {
        //camera_mouse = !camera_mouse; 

    }else
    
    if (key == VK_SPACE) 
    {

        robot->toggle_automode();
        
        if (robot->get_automode())
            alert(MODULE_NAME "Auto mode");
        else
            alert(MODULE_NAME "Manual mode");                
            

    }else
    
    if (key == '1') gui_speed = 0.3; else
    if (key == '2') gui_speed = 0.35; else
    if (key == '3') gui_speed = 0.4; else
    if (key == '4') gui_speed = 0.45; else
    if (key == '5') gui_speed = 0.5; else
    if (key == '6') gui_speed = 0.6; else
    if (key == '7') gui_speed = 0.7; else
    if (key == '8') gui_speed = 0.8; else
    if (key == '9') gui_speed = 0.9; else
    if (key == '0') gui_speed = 1.0;  
    

    // Mark key
    keys[key] = true;

    update_movement();
}
/* End of process key down */


/* Called when a key is released */
void main_class::process_key_up( unsigned char key )
{
    log(MODULE_NAME "process_key_up\n");

    keys[key] = false;

    update_movement();
        
}
/* End of process key up */



