/*
    NullBot Robot Client 

    (C) 2005-2011 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com

    FILE: types.h
*/

#ifndef TYPES_H
#define TYPES_H

#define DEBUG_HEADER 0

#define log_header()  if (DEBUG_HEADER) { log(MODULE_NAME "%s\n", __FUNCTION__); } 

#define CLAMP(V, L1, L2) { if (V < (L1)) V = (L1); if (V > (L2)-1) V = (L2) - 1; }



// Forward all classes
class main_class;
class robot_class;
class network_class;
class camera_class;
class profile_class;






// interface to windows colors
typedef struct color_type
{
    unsigned char b, g, r;
};



typedef struct point
{
    double x,y;
};



union integer32
{
    unsigned int n;

    struct
    {
        unsigned int b0 : 8;
        unsigned int b1 : 8;
        unsigned int b2 : 8;
        unsigned int b3 : 8;
    } bytes;

    struct
    {
        unsigned int lowWord : 16;
        unsigned int highWord : 16;
    } words;     
};



#endif









