/*
    NullBot Robot Platform - Server - 2005-2011 Jason Hunt
    
    GNU GENERAL PUBLIC LICENSE Version 2, June 1991
        
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
    File: robot.h
*/

#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "../netcomm.h"

#include <pthread.h>




#define HEADER_SIZE 2
#define FOOTER_SIZE 1


#define UPDATE_RATE 20          // Update rate in hz

#define LINK_QUALITY_MAX   100.0



typedef struct
{
    unsigned char c_data[4];    // Control data
    float analog_data[16];      // Telemetry data

    unsigned char raw_telemetry[COMM_IN_TEL_LEN];


    unsigned char wifi_link;


    pthread_t robot_t;

    int client_updates;
    int serial_updates;


} robot_type;


void robot_start ( void );
void robot_stop ( void );

void robot_reset ( void );

void robot_parse_telemetry( unsigned char * buffer, unsigned int len );  
void robot_set_control(unsigned char * buffer, unsigned int len);

unsigned int robot_check_client( void );
unsigned int robot_check_serial( void );




#endif



 
