/*
	NullBot Robot Platform - NodeIO - 2005-2011 Jason Hunt

	Contact: nulluser@gmail.com
    
	GNU GENERAL PUBLIC LICENSE Version 2, June 1991

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	File: main.h
*/

#ifndef MAIN_H
#define MAIN_H

#define interrupt_disable()  asm volatile ("disi #0x3FFF");
#define interrupt_enable()   asm volatile ("disi #0");

#define ABS(a)	   (((a) < 0) ? -(a) : (a))

#define FOSC		80000000		// Instruction clock    10 MHZ xtal  HS PLLx8
#define FCY	  	(FOSC / 4)		// Instruction clock    10 MHZ xtal  HS PLLx8



#define led		_LATC13			// I/O Pin definitions
#define buzzer		_RD8

#define MAX_TASKS  10


void task_register ( void fn (void) );
void task_poll (void );

extern unsigned char fault;
extern unsigned char fault_data;

#endif

